# $Revision: 1.39 $, $Date: 2007/03/01 13:53:43 $
Summary:	DConnect Daemon - Hub D****ct Connect for Linux
Summary(pl):	DConnect Daemon - Hub D****ct Connecta dla Linuksa
Name:		dcd
Version:	1.1.1
Release:	1
License:	GPL v2
Group:		Networking/Daemons
Vendor:		DConnect Team <dc-hub@ds.pg.gda.pl>
Source0:	ftp://pollux.ds.pg.gda.pl/Linux/DConnect/sources/stable/%{name}-%{version}.tar.gz
URL:		http://www.dc.ds.pg.gda.pl/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	libwrap-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
This is Linux D*** Connect Hub implementation for Linux. It works in
daemon mode and utilizes threads.

%description -l pl
Pakiet zawiera Linuksow implementacj huba D*** Connecta, ktry 
pracuje jako demon i uywa wtkw.

%prep
%setup -q

%build
export NOCONFIGURE=1
./autogen.sh
unset NOCONFIGURE

%configure \
	--with-config-dir=%{_sysconfdir}/dcd \
	--sbindir=%{_sbindir} \
	--with-group=daemon \
	--with-user=daemon

make

%install
rm -rf $RPM_BUILD_ROOT
#install -d $RPM_BUILD_ROOT{/etc/{sysconfig,rc.d/init.d,logrotate.d},/var/log/archiv/dcd}
install -d $RPM_BUILD_ROOT{/etc/{sysconfig,rc.d/init.d,logrotate.d}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install contrib/PLD/dcd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/dcd
install contrib/dcd.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/dcd
install contrib/logrotate.dcd $RPM_BUILD_ROOT/etc/logrotate.d/dcd

#touch $RPM_BUILD_ROOT@LOG_DIR@/dcd.log

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add dcd
if [ -f /var/lock/subsys/dcd ]; then
        /etc/rc.d/init.d/dcd restart 1>&2
else
        echo "Run \"/etc/rc.d/init.d/dcd start\" to start DConnect Daemon."
fi

%preun
if [ "$1" = "0" ]; then
        if [ -f /var/lock/subsys/dcd ]; then
                /etc/rc.d/init.d/dcd stop 1>&2
        fi
        /sbin/chkconfig --del dcd
fi

%triggerpreun -- dcd < 0.1.1
echo "Upgrading from version < 0.1.1"
echo "Remember to review config - the options were changed!!!"
if [ -e /etc/dcd/dchub.conf ]; then
	cp ${prefix}/etc/dcd/dcd.conf ${prefix}/etc/dcd/dcd.conf.new
	cp ${prefix}/etc/dcd/dchub.conf ${prefix}/etc/dcd/dcd.conf
fi

%triggerpostun -- dcd < 0.3.5
echo "Upgrading from version < 0.3.5"
if [ -e /etc/dcd/console.users.rpmsave ]; then
	cp /etc/dcd/dcd.users /etc/dcd/dcd.users.rpmnew
	cp /etc/dcd/console.users.rpmsave /etc/dcd/dcd.users
fi
echo "Remember to review config - console users has been changed into dcd.users"
cp /etc/dcd/dcd.conf /etc/dcd/dcd.conf.rpmsave
sed -e s/console.users/dcd.users/g /etc/dcd/dcd.conf >/etc/dcd/dcd.conf.tmp
mv -f /etc/dcd/dcd.conf.tmp /etc/dcd/dcd.conf

%files
%defattr(644,root,root,755)
%doc AUTHORS BUGS FAQ NEWS README TODO USERCOMMANDS SYSLOG
%attr(755,root,root) %{_sbindir}/dcd
%attr(755,root,root) /etc/rc.d/init.d/dcd
%attr(770,daemon,daemon) %config(noreplace) %{_sysconfdir}/dcd
%attr(660,daemon,daemon) %config(noreplace) %{_sysconfdir}/dcd/*
%attr(644,root,root) %config(noreplace) /etc/sysconfig/dcd
%attr(644,root,root) %config(noreplace) /etc/logrotate.d/dcd
#%attr(644,daemon,root) @LOG_DIR@/dcd.log
#%attr(755,daemon,root) %dir @LOG_DIR@
#%dir /var/log/archiv/dcd
%{_mandir}/man1/*.1*
%{_mandir}/man2/*.2*

%define date    %(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} DConnect Daemon <dc-hub@ds.pg.gda.pl>

$Log: dcd.spec.in,v $
Revision 1.39  2007/03/01 13:53:43  rav


cleaning specs files

Revision 1.38  2007/03/01 13:41:22  rav


* dcd.conf.in
- SYSLOG added:
- option log_facility added
- removed unused options

* SYSLOG
- introduction to syslog-ng

* configure.ac
- removing option --with-log-dir

* dcd.spec
- SYSLOG added

Revision 1.37  2006/08/30 19:28:42  blues
- updated docs in spec

Revision 1.36  2005/02/05 13:34:44  rav


- fix SIGSEGV because of /etc/dcd.penalties file

Revision 1.35  2005/02/05 02:13:29  rav


- from now on ./autogen.sh is used before ./configure while building RPM

Revision 1.34  2005/02/05 01:37:03  rav


- sync

Revision 1.33  2005/02/05 01:13:29  rav


- fixing paths

Revision 1.32  2005/02/04 22:52:37  rav


rolling back last changes

Revision 1.30  2004/04/23 22:11:09  blues
- added proper trigger for automatic upgrade

Revision 1.29  2004/02/15 17:37:49  blues
- fix for recent changes

Revision 1.28  2003/02/02 15:37:07  blues
- commented out fragments that made problems on some linux distros

Revision 1.27  2003/01/13 07:19:48  blues
- added new files to spec, forgotten files removed and forgotten added

Revision 1.26  2002/12/21 23:14:26  blues
- more macros in contrib part (one file was existing and was missing in
  package...)
- TODO updated
- LOG_DIR is now taken as optional configure option, commented out
  hardcoded location from code
- more macros in configuration

Revision 1.25  2002/12/19 01:54:14  blues
- fixed working of join/quit message

Revision 1.24  2002/12/19 00:46:39  blues
- updated sample spec: fixed permisions, fixed trigger
- added info about recent changes

Revision 1.23  2002/12/17 03:33:20  blues
- use daemon user in spec

Revision 1.22  2002/12/14 10:34:21  blues
- added new config files to spec

Revision 1.21  2002/08/30 15:13:26  blues
- fix in logdir properties

Revision 1.20  2002/08/30 14:55:32  blues
- this should be done in preun, not postun

Revision 1.19  2002/08/30 14:51:48  blues
- cosmetic

Revision 1.18  2002/08/29 12:19:41  blues
- more macros, added trigger for upgrade from previous version (keep
  previous configuration)

Revision 1.17  2002/08/06 21:50:34  blues
- move logs by default to /var/log/dcd/ directory

Revision 1.16  2002/08/06 21:44:18  blues
- added Vendor entry

Revision 1.15  2002/07/08 13:32:57  blues
- *** empty log message ***

Revision 1.14  2002/06/30 09:32:30  blues
- permisions to logfile

Revision 1.13  2002/06/30 04:17:34  blues
- sort in alfabetical order

Revision 1.12  2002/06/30 04:13:44  blues
- added log

Revision 1.11  2002/06/28 20:51:52  blues
- added FAQ - feel free to fill it :)

Revision 1.10  2002/06/15 12:01:46  blues
- better (correct) handle of config file

Revision 1.9  2002/06/04 23:59:47  blues
- fixed config-file location

Revision 1.8  2002/05/31 17:55:29  blues
- fixed handling config, reverted my mistakes, fixed initscripts and specs

Revision 1.7  2002/05/18 12:30:58  blues
- gziping docs moved to build section in PLD spec
- cosmetics in some files

Revision 1.6  2002/05/08 16:04:56  blues
- fixes to spec by PLD-team :) <qboosh@pld.org.pl>, <kloczek@pld.org.pl>
- more buildrequires, some spellings.

Revision 1.5  2002/04/28 12:49:01  blues
- This is finally 0.0.2 :)
- info in config
- configs marked as config(noreplace)

Revision 1.4  2002/04/28 02:10:27  blues
- added one buildrequire to spec

Revision 1.3  2002/04/28 01:45:12  blues
- added post and postun section in contrib/PLD/dcd.spec.in

Revision 1.2  2002/04/28 00:35:24  blues
- dchub.conf moved to autogenerated version - few more fixes

Revision 1.1  2002/04/27 21:26:16  blues
- started making contrib directory

Revision 1.4  2002/04/27 21:05:31  blues
- More automatics and one fix...

Revision 1.3  2002/03/28 21:17:15  blues
- config added

Revision 1.2  2002/03/28 20:53:31  blues
- some fixes

